package org.directwebremoting.servlet;

import java.io.IOException;
import org.directwebremoting.servlet.BaseEngineHandler;
import org.directwebremoting.servlet.DojoModule;

public class DojoEngineHandler extends BaseEngineHandler {

   protected String dojoDwrBaseModulePath;


   protected String generateTemplate(String contextPath, String servletPath, String pathInfo) throws IOException {
      DojoModule mod = new DojoModule(contextPath, servletPath, this.dojoDwrBaseModulePath, "engine");
      boolean remap = !this.dojoDwrBaseModulePath.equals("dwr");
      if(remap) {
         mod.addContent("(function(dwr) {\n");
         mod.addContent("\n");
      }

      mod.addContent(super.generateTemplate(contextPath, servletPath, pathInfo));
      if(remap) {
         mod.addContent("\n");
         mod.addContent("})(" + mod.expandModulePath(this.dojoDwrBaseModulePath) + ");\n");
      }

      return mod.toString();
   }

   public void setDojoDwrBaseModulePath(String modulePath) {
      this.dojoDwrBaseModulePath = modulePath;
   }
}
